module Address where

import OrbitVM (Addr)

-- input port
addrConf, addrDVx, addrDVy :: Addr
addrConf = 0x3e80
addrDVx = 0x2
addrDVy = 0x3

-- Common sensor output ports
addrScore, addrFuelRemaining, addrX, addrY :: Addr
addrScore = 0x0
addrFuelRemaining = 0x1
addrX = 0x2
addrY = 0x3

-- Hohmann Problem sensor output ports
addrTargetRadius :: Addr
addrTargetRadius = 0x4

-- Meet and Greet  sensor output ports
addrTargetX, addrTargetY :: Addr
addrTargetX = 0x4
addrTargetY = 0x5

-- Operation Clear Skies sensor output ports
addrFuelingStationX, addrFuelingStationY, addrFuelingStationRemaining :: Addr
addrFuelingStationX = 0x4
addrFuelingStationY = 0x5
addrFuelingStationRemaining = 0x6

addrTargetNX, addrTargetNY, addrTargetNCollected :: Int -> Addr
addrTargetNX k = 3*k + 0x7
addrTargetNY k = 3*k + 0x8
addrTargetNCollected k = 3*k + 0x8
