{-# LANGUAGE MultiParamTypeClasses #-}
module Ref (Ref (..)) where

import Control.Monad.ST
import Data.STRef
import Data.IORef

class Monad m => Ref r m where
  readRef  :: r a -> m a
  writeRef :: r a -> a -> m ()
  modifyRef :: r a -> (a -> a) -> m ()
  modifyRef r f = readRef r >>= \x -> writeRef r (f x)

instance Ref (STRef s) (ST s) where
  readRef  = readSTRef
  writeRef = writeSTRef
  modifyRef = modifySTRef

instance Ref IORef IO where
  readRef  = readIORef
  writeRef = writeIORef
  modifyRef = modifyIORef
